package com.joshvm.demo;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;

/**
 * RS485实例：通过RS458，收发数据
 * 前提：使用COM2；需要485传感器
 */
public class RS485Demo {
	
	// 根据硬件及接线设定串口的com口
	private static String com = "COM2";
	// 波特率
	private static int baudrate = 9600;

	private static StreamConnection streamConnection;
	private static InputStream inputStream;
	private static OutputStream outputStream;

	public static void main(String[] args) {

		System.out.println("Start RS485 Demo...");

		String host = "comm:" + com + ";baudrate=" + baudrate;

		try {

			// 建立连接
			streamConnection = (StreamConnection) Connector.open(host);
			inputStream = streamConnection.openInputStream();
			outputStream = streamConnection.openOutputStream();

			// 启动子线程，每1s发送数据
			new Thread(new Runnable() {

				public void run() {

					while (true) {
						try {
							Thread.sleep(1000);
							outputStream.write("Message".getBytes());
						} catch (InterruptedException e) {
							e.printStackTrace();
						} catch (IOException e) {
							e.printStackTrace();
						}
					}
				}
			}).start();

			int len = 0;
			byte[] buffer = new byte[256];
			
			try {
				// 读数据
				while ((len = inputStream.read(buffer)) != -1) {

					String message = new String(buffer, 0, len);
					System.out.println("get message: " + message);
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		} catch (IOException e) {
			e.printStackTrace();
		} 
	}
	
}
